Attribute VB_Name = "Declares"
Option Explicit

Public Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long

Public Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function GetCapture Lib "user32" () As Long
Public Declare Function ReleaseCapture Lib "user32" () As Long

Public Declare Function ClipCursor Lib "user32" (lpRect As Any) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Public Declare Function MoveToEx Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, lpPoint As PointAPI) As Long
Public Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Public Declare Function LineTo Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long

Public Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Public Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hDC As Long) As Long

Public Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function SetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

Public Declare Function ClientToScreen Lib "user32" (ByVal hWnd As Long, lpPoint As PointAPI) As Long
Public Declare Function SetCursorPos Lib "user32" (ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function GetCursorPos Lib "user32" (lpPoint As PointAPI) As Long

Public Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Public Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long

Public Const COLORRES = 108          '  Actual color resolution
Public Const BITSPIXEL = 12          '  Number of bits per pixel

Public Const SRCCOPY = &HCC0020

Public Const PS_SOLID = 0 'PenStyle

Public Const BM_SETSTYLE = &HF4 'ButtonMessage
Public Const BS_MULTILINE = &H2000&

Global Const SWP_NOMOVE = 2 'SetWindowPos
Global Const SWP_NOSIZE = 1
Global Const FLAGS = SWP_NOMOVE Or SWP_NOSIZE
Global Const HWND_TOPMOST = -1
Global Const HWND_NOTOPMOST = -2

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type PointAPI
    X As Long
    Y As Long
End Type

Public Type RGBColT
    R As Integer
    B As Integer
    G As Integer
End Type

Public Type HSLColT
    Hue As Integer
    Sat As Integer
    Lum As Integer
End Type

Public maxVal As Integer
Public PickerMode As PickerModeE

Public HSLColor As HSLColT
Public RGBColor As RGBColT

Public Enum PickerModeE
    Rot = 0
    Grn = 1
    Blau = 2
    Hue = 3
    Sat = 4
    Lum = 5
    WebHex = 6
    OtherInput = 7
End Enum

Public Enum DirecGrad
    Horiz
    vertic
End Enum

Public Enum CCase
    LowerCase = 0
    UpperCase = 1
End Enum

Public Function fillRGBCol(ByVal Color As Long, ByRef RGBCol As RGBColT)
    RGBCol.R = getRedVal(Color)
    RGBCol.G = getGreenVal(Color)
    RGBCol.B = getBlueVal(Color)

End Function

Public Function setCButtons(frm As Form)
    Dim btn As Control

    For Each btn In frm.Controls
        If TypeName(btn) = "CommandButton" Then
            SendMessage btn.hWnd, BM_SETSTYLE, &H0&, 0& '&HF4& durch BM_SETSTYLE
            SendMessage btn.hWnd, BM_SETSTYLE, BS_MULTILINE, 0&

        End If
    Next btn

End Function

Public Function RGBGrad(obj As Object, Col1 As Long, Col2 As Long, Optional Dgrad As DirecGrad = vertic, Optional WebSafe As Boolean = False)
    Dim R1, R2, G1, G2, B1, B2, Sr, Sg, Sb, H%, H2%, xxx%
    Dim tRGBCol As RGBColT
    Dim R, G, B

    Dim TmpScale%
    On Error Resume Next
    If IsMissing(Dgrad) Then Dgrad = vertic
    TmpScale = obj.ScaleMode
    obj.ScaleMode = 3
    obj.AutoRedraw = True
    R1 = getRedVal(Col1)
    R2 = getRedVal(Col2)
    G1 = getGreenVal(Col1)
    G2 = getGreenVal(Col2)
    B1 = getBlueVal(Col1)
    B2 = getBlueVal(Col2)

    If Dgrad = Horiz Then
        H = obj.ScaleHeight
    Else
        H = obj.ScaleWidth
    End If
    Sr = (R2 - R1) / H
    Sg = (G2 - G1) / H
    Sb = (B2 - B1) / H
    For xxx = 0 To H
        tRGBCol.R = R1
        tRGBCol.G = G1
        tRGBCol.B = B1

        If WebSafe Then tRGBCol = makeWebSafe(tRGBCol)

        If Dgrad = Horiz Then
            DrawLine obj.hDC, 0, xxx, obj.ScaleWidth, xxx, RGB(tRGBCol.R, tRGBCol.G, tRGBCol.B)
        Else
            DrawLine obj.hDC, xxx, 0, xxx, obj.ScaleWidth, RGB(tRGBCol.R, tRGBCol.G, tRGBCol.B)
        End If
        R1 = R1 + Sr
        G1 = G1 + Sg
        B1 = B1 + Sb
    Next xxx
    obj.ScaleMode = TmpScale
End Function

Public Function HSLGrad(obj As Object, HSLCol1 As HSLColT, HSLCol2 As HSLColT, Optional Dgrad As DirecGrad = vertic, Optional WebSafe As Boolean = False)
    Dim H1, H2, S1, S2, L1, L2, Sh, Ss, Sl, Ha%, Ha2%, xxx%
    Dim tRGBCol As RGBColT, tHSLCol As HSLColT
    Dim H, S, L
    Dim TmpScale%
    On Error Resume Next

    If IsMissing(Dgrad) Then Dgrad = vertic
    TmpScale = obj.ScaleMode
    obj.ScaleMode = 3
    obj.AutoRedraw = True

    H1 = HSLCol1.Hue
    H2 = HSLCol2.Hue
    S1 = HSLCol1.Sat
    S2 = HSLCol2.Sat
    L1 = HSLCol1.Lum
    L2 = HSLCol2.Lum

    If Dgrad = Horiz Then
        Ha = obj.ScaleHeight
    Else
        Ha = obj.ScaleWidth
    End If

    Sh = (H2 - H1) / Ha
    Ss = (S2 - S1) / Ha
    Sl = (L2 - L1) / Ha

    For xxx = 0 To Ha
        tHSLCol.Hue = H1
        tHSLCol.Sat = S1
        tHSLCol.Lum = L1

        HSLtoRGB tHSLCol, tRGBCol

        If WebSafe Then tRGBCol = makeWebSafe(tRGBCol)

        If Dgrad = Horiz Then
            DrawLine obj.hDC, 0, xxx, obj.ScaleWidth, xxx, RGB(tRGBCol.R, tRGBCol.G, tRGBCol.B)
        Else
            DrawLine obj.hDC, xxx, 0, xxx, obj.ScaleWidth, RGB(tRGBCol.R, tRGBCol.G, tRGBCol.B)
        End If

        H1 = H1 + Sh
        S1 = S1 + Ss
        L1 = L1 + Sl
    Next xxx

    obj.ScaleMode = TmpScale

End Function

Public Sub DrawLine(hDC As Long, x1 As Integer, y1 As Integer, _
    x2 As Integer, y2 As Integer, col As Long, _
    Optional DrawWidth As Integer = 1, _
    Optional DrawStyle As Integer = PS_SOLID)

    Dim dummy As PointAPI
    Dim lRet As Long, hPen As Long, hOldPen As Long

    lRet = MoveToEx(hDC, x1, y1, dummy)
    Debug.Assert lRet <> 0
    hPen = CreatePen(DrawStyle, DrawWidth, col)
    hOldPen = SelectObject(hDC, hPen)

    lRet = LineTo(hDC, x2, y2)
    Debug.Assert lRet <> 0
    lRet = SelectObject(hDC, hOldPen)
    Debug.Assert lRet <> 0
    lRet = DeleteObject(hPen)
    Debug.Assert lRet <> 0

End Sub
Public Sub RGBtoHSL(RGBCol As RGBColT, HSLCol As HSLColT)
    Dim tHSL As HSLColT

    tHSL = cRGBtoHSL(RGB(RGBCol.R, RGBCol.G, RGBCol.B))

    If tHSL.Hue = UNDEFINED Then 'Wenn -1, dann wird der alte Hue Wert ausgegeben
        tHSL.Hue = HSLCol.Hue
    End If

    HSLCol = tHSL

End Sub

Public Sub HSLtoRGB(HSLCol As HSLColT, RGBCol As RGBColT)
    Dim RGBLong As Long

    RGBLong = cHSLtoRGB(HSLCol)

    BreakApart RGBLong, RGBCol
End Sub

Public Function BreakApart(ByVal Color As Long, ByRef RGBCol As RGBColT)
    RGBCol.R = getRedVal(Color)
    RGBCol.G = getGreenVal(Color)
    RGBCol.B = getBlueVal(Color)

End Function
Public Function Char2WebHex(char As Integer, Optional CharCase As CCase = LowerCase) As String
    Dim C As String
    C = Hex(char)
    If Len(C) Mod 2 <> 0 Then C = "0" & C
    If CharCase = LowerCase Then
        Char2WebHex = LCase(C)
    Else
        Char2WebHex = C
    End If

End Function

Public Function WebHex2Char(str As String) As RGBColT
    Dim R As Variant, G As Variant, B As Variant, t

    t = Replace(str, "#", "")
    R = Mid(t, 1, 2)
    G = Mid(t, 3, 2)
    B = Mid(t, 5, 2)

    R = Val("&H" & R) 'Hex in Dezimal durch Val
    G = Val("&H" & G)
    B = Val("&H" & B)

    WebHex2Char.R = R
    WebHex2Char.G = G
    WebHex2Char.B = B

End Function

Public Sub fullSelection(txtObj As Object)
    ReleaseCapture
    txtObj.SelStart = 0
    txtObj.SelLength = Len(txtObj.Text)

End Sub

Public Function ContrastingColor(RGBCol As Long) As Long
    Dim R As Integer, G As Integer, B As Integer
    R = getRedVal(RGBCol)
    G = getGreenVal(RGBCol)
    B = getBlueVal(RGBCol)

    'Rot 30%, Grn 59%, Blau 11%
    'entspricht in etwa der Farbempfindlichkeit des menschl. Auges
    '(auch Graustufenberechnung nach dem CIE-L*A*B Standard)

    If (R * 0.3 + G * 0.59 + B * 0.11) >= 128 Then
        ContrastingColor = vbBlack
    Else
        ContrastingColor = vbWhite
    End If
End Function

Public Function setRange(ByVal num As Long, ByVal min As Long, ByVal max As Long)
    If num > max Then
        num = max
    ElseIf num < min Then
        num = min
    End If
    setRange = num

End Function

Public Function getRedVal(ByVal RGBCol As Long) As Integer
    If RGBCol < 0 Then 'Systemfarben in lesbare Werte umwandeln
        RGBCol = GetSysColor(RGBCol And &H7FFFFFFF)
    End If

    If RGBCol < 0 Then RGBCol = 0
    getRedVal = RGBCol And &HFF

End Function

Public Function getGreenVal(ByVal RGBCol As Long) As Integer
    If RGBCol < 0 Then 'Systemfarben in lesbare Werte umwandeln
        RGBCol = GetSysColor(RGBCol And &H7FFFFFFF)
    End If

    getGreenVal = ((RGBCol And &H100FF00) / &H100)

End Function

Public Function getBlueVal(ByVal RGBCol As Long) As Integer
    If RGBCol < 0 Then 'Systemfarben in lesbare Werte umwandeln
        RGBCol = GetSysColor(RGBCol And &H7FFFFFFF)
    End If

    getBlueVal = (RGBCol And &HFF0000) / &H10000

End Function

Public Function makeWebSafe(RGBCol As RGBColT) As RGBColT
    Dim wsvR As Integer, wsvG As Integer, wsvB As Integer, wsvC As Long, PLevel As Integer
    Dim red As Integer, green As Integer, blue As Integer
    Dim RedMod As Integer, GreenMod As Integer, BlueMod As Integer
    Dim delimiter As Integer, stepping As Integer

    delimiter = 25
    stepping = 51

    red = RGBCol.R
    green = RGBCol.G
    blue = RGBCol.B

    If red Mod stepping <> 0 Then
        RedMod = red Mod stepping
        wsvR = red - RedMod
        If Not RedMod <= delimiter Then
            If wsvR + stepping <= 255 Then wsvR = wsvR + stepping

        End If
    Else
        wsvR = red
    End If

    If green Mod stepping <> 0 Then
        GreenMod = green Mod stepping
        wsvG = green - GreenMod
        If Not GreenMod <= delimiter Then
            If wsvG + stepping <= 255 Then wsvG = wsvG + stepping

        End If
    Else
        wsvG = green
    End If

    If blue Mod stepping <> 0 Then
        BlueMod = blue Mod stepping
        wsvB = blue - BlueMod
        If Not BlueMod <= delimiter Then
            If wsvB + stepping <= 255 Then wsvB = wsvB + stepping

        End If
    Else
        wsvB = blue
    End If

    makeWebSafe.R = wsvR
    makeWebSafe.G = wsvG
    makeWebSafe.B = wsvB

End Function

